use crate::pos::Pos;

#[derive(Clone, PartialEq, Debug)]
pub struct Token {
    pub kind: TokenKind,
    pub value: TokenValue,
    pub pos: Pos,
}

#[derive(Clone, PartialEq, Debug)]
pub enum TokenKind {
    Error,
    Id,
    Int,
    Str,
    If,
    Else,
    Loop,
    Break,
    Let,
    Fn,
    Return,
    LParen,
    RParen,
    LBrace,
    RBrace,
    Colon,
    Comma,
    Semicolon,
    Equal,
    MinusLt,
}

#[derive(Clone, PartialEq, Debug)]
pub enum TokenValue {
    None,
    Id(u64),
    Int(i64),
    Str(String),
}
